<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head><meta http-equiv="content-type" content="text/html; charset=UTF-8" />
<title>ChoosePorts xref</title>
<link type="text/css" rel="stylesheet" href="../../../../../../../../stylesheet.css" />
</head>
<body>
<div id="overview"><a href="../../../../../../../../../apidocs/org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ChoosePorts.html">View Javadoc</a></div><pre>
<a class="jxr_linenumber" name="L1" href="#L1">1</a>   <em class="jxr_javadoccomment">/*****************************************************************************</em>
<a class="jxr_linenumber" name="L2" href="#L2">2</a>   <em class="jxr_javadoccomment"> * Copyright (c) 2013 CEA LIST.</em>
<a class="jxr_linenumber" name="L3" href="#L3">3</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L4" href="#L4">4</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L5" href="#L5">5</a>   <em class="jxr_javadoccomment"> * All rights reserved. This program and the accompanying materials</em>
<a class="jxr_linenumber" name="L6" href="#L6">6</a>   <em class="jxr_javadoccomment"> * are made available under the terms of the Eclipse Public License v1.0</em>
<a class="jxr_linenumber" name="L7" href="#L7">7</a>   <em class="jxr_javadoccomment"> * which accompanies this distribution, and is available at</em>
<a class="jxr_linenumber" name="L8" href="#L8">8</a>   <em class="jxr_javadoccomment"> * <a href="http://www.eclipse.org/legal/epl-v10.htm" target="alexandria_uri">http://www.eclipse.org/legal/epl-v10.htm</a>l</em>
<a class="jxr_linenumber" name="L9" href="#L9">9</a>   <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L10" href="#L10">10</a>  <em class="jxr_javadoccomment"> * Contributors:</em>
<a class="jxr_linenumber" name="L11" href="#L11">11</a>  <em class="jxr_javadoccomment"> *  Ansgar Radermacher  ansgar.radermacher@cea.fr</em>
<a class="jxr_linenumber" name="L12" href="#L12">12</a>  <em class="jxr_javadoccomment"> *</em>
<a class="jxr_linenumber" name="L13" href="#L13">13</a>  <em class="jxr_javadoccomment"> *****************************************************************************/</em>
<a class="jxr_linenumber" name="L14" href="#L14">14</a>  
<a class="jxr_linenumber" name="L15" href="#L15">15</a>  <strong class="jxr_keyword">package</strong> org.eclipse.papyrus.designer.components.transformation.ui.dialogs;
<a class="jxr_linenumber" name="L16" href="#L16">16</a>  
<a class="jxr_linenumber" name="L17" href="#L17">17</a>  <strong class="jxr_keyword">import</strong> java.util.ArrayList;
<a class="jxr_linenumber" name="L18" href="#L18">18</a>  <strong class="jxr_keyword">import</strong> java.util.Collections;
<a class="jxr_linenumber" name="L19" href="#L19">19</a>  
<a class="jxr_linenumber" name="L20" href="#L20">20</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.BasicEList;
<a class="jxr_linenumber" name="L21" href="#L21">21</a>  <strong class="jxr_keyword">import</strong> org.eclipse.emf.common.util.EList;
<a class="jxr_linenumber" name="L22" href="#L22">22</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.components.FCM.InterceptionRule;
<a class="jxr_linenumber" name="L23" href="#L23">23</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.designer.transformation.base.utils.ElementUtils;
<a class="jxr_linenumber" name="L24" href="#L24">24</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.profile.ui.dialogs.AlphabeticalViewerSorter;
<a class="jxr_linenumber" name="L25" href="#L25">25</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.profile.ui.dialogs.ChooseSetAssistedDialog;
<a class="jxr_linenumber" name="L26" href="#L26">26</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.profile.ui.dialogs.IChooseDialog;
<a class="jxr_linenumber" name="L27" href="#L27">27</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.properties.profile.ui.dialogs.StereotypeQualifiedLabelProvider;
<a class="jxr_linenumber" name="L28" href="#L28">28</a>  <strong class="jxr_keyword">import</strong> org.eclipse.papyrus.uml.tools.utils.PackageUtil;
<a class="jxr_linenumber" name="L29" href="#L29">29</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.SWT;
<a class="jxr_linenumber" name="L30" href="#L30">30</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionAdapter;
<a class="jxr_linenumber" name="L31" href="#L31">31</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.events.SelectionEvent;
<a class="jxr_linenumber" name="L32" href="#L32">32</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Composite;
<a class="jxr_linenumber" name="L33" href="#L33">33</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Control;
<a class="jxr_linenumber" name="L34" href="#L34">34</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.Shell;
<a class="jxr_linenumber" name="L35" href="#L35">35</a>  <strong class="jxr_keyword">import</strong> org.eclipse.swt.widgets.TableColumn;
<a class="jxr_linenumber" name="L36" href="#L36">36</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Class;
<a class="jxr_linenumber" name="L37" href="#L37">37</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Feature;
<a class="jxr_linenumber" name="L38" href="#L38">38</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Package;
<a class="jxr_linenumber" name="L39" href="#L39">39</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Port;
<a class="jxr_linenumber" name="L40" href="#L40">40</a>  <strong class="jxr_keyword">import</strong> org.eclipse.uml2.uml.Property;
<a class="jxr_linenumber" name="L41" href="#L41">41</a>  
<a class="jxr_linenumber" name="L42" href="#L42">42</a>  
<a class="jxr_linenumber" name="L43" href="#L43">43</a>  <strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ChoosePorts.html">ChoosePorts</a> <strong class="jxr_keyword">extends</strong> ChooseSetAssistedDialog <strong class="jxr_keyword">implements</strong> IChooseDialog {
<a class="jxr_linenumber" name="L44" href="#L44">44</a>  
<a class="jxr_linenumber" name="L45" href="#L45">45</a>  	<strong class="jxr_keyword">protected</strong> EList&lt;Package&gt; visitedPackages;
<a class="jxr_linenumber" name="L46" href="#L46">46</a>  
<a class="jxr_linenumber" name="L47" href="#L47">47</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L48" href="#L48">48</a>  <em class="jxr_javadoccomment">	 * LabelProvider for stereotype completion proposal provider with qualified names.</em>
<a class="jxr_linenumber" name="L49" href="#L49">49</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L50" href="#L50">50</a>  	<strong class="jxr_keyword">final</strong> <strong class="jxr_keyword">private</strong> StereotypeQualifiedLabelProvider qualifiedLabelProvider = <strong class="jxr_keyword">new</strong> StereotypeQualifiedLabelProvider();
<a class="jxr_linenumber" name="L51" href="#L51">51</a>  
<a class="jxr_linenumber" name="L52" href="#L52">52</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L53" href="#L53">53</a>  <em class="jxr_javadoccomment">	 * Default Constructor.</em>
<a class="jxr_linenumber" name="L54" href="#L54">54</a>  <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L55" href="#L55">55</a>  <em class="jxr_javadoccomment">	 * @param parentShell</em>
<a class="jxr_linenumber" name="L56" href="#L56">56</a>  <em class="jxr_javadoccomment">	 *            the parent shell</em>
<a class="jxr_linenumber" name="L57" href="#L57">57</a>  <em class="jxr_javadoccomment">	 * @param theElement</em>
<a class="jxr_linenumber" name="L58" href="#L58">58</a>  <em class="jxr_javadoccomment">	 *            the UML element to be modified</em>
<a class="jxr_linenumber" name="L59" href="#L59">59</a>  <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L60" href="#L60">60</a>  	<strong class="jxr_keyword">public</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ChoosePorts.html">ChoosePorts</a>(Shell parentShell, Class component, <a href="../../../../../../../../org/eclipse/papyrus/designer/components/FCM/InterceptionRule.html">InterceptionRule</a> rule) {
<a class="jxr_linenumber" name="L61" href="#L61">61</a>  		<strong class="jxr_keyword">super</strong>(parentShell, <span class="jxr_string">"Available features"</span>, <span class="jxr_string">"Intercepted features"</span>);
<a class="jxr_linenumber" name="L62" href="#L62">62</a>  		labelProvider = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/PortLabelProvider.html">PortLabelProvider</a>();
<a class="jxr_linenumber" name="L63" href="#L63">63</a>  		decoratedContentProposalProvider = <strong class="jxr_keyword">new</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ChoosePorts.html">ConfigOptContentProposalProvider</a>();
<a class="jxr_linenumber" name="L64" href="#L64">64</a>  
<a class="jxr_linenumber" name="L65" href="#L65">65</a>  		<strong class="jxr_keyword">for</strong> (Feature feature : rule.getInterceptionSet()) {
<a class="jxr_linenumber" name="L66" href="#L66">66</a>  			selectedElementList.addElement(feature);
<a class="jxr_linenumber" name="L67" href="#L67">67</a>  		}
<a class="jxr_linenumber" name="L68" href="#L68">68</a>  
<a class="jxr_linenumber" name="L69" href="#L69">69</a>  		visitedPackages = <strong class="jxr_keyword">new</strong> BasicEList&lt;Package&gt;();
<a class="jxr_linenumber" name="L70" href="#L70">70</a>  		<strong class="jxr_keyword">if</strong> (component != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L71" href="#L71">71</a>  			<em class="jxr_comment">// local rule with intercept some policy: choose executor ports</em>
<a class="jxr_linenumber" name="L72" href="#L72">72</a>  			<strong class="jxr_keyword">for</strong> (Property current : component.getOwnedAttributes()) {
<a class="jxr_linenumber" name="L73" href="#L73">73</a>  				<strong class="jxr_keyword">if</strong> (!selectedElementList.contains(current)) {
<a class="jxr_linenumber" name="L74" href="#L74">74</a>  					possibleElementList.addElement(current);
<a class="jxr_linenumber" name="L75" href="#L75">75</a>  				}
<a class="jxr_linenumber" name="L76" href="#L76">76</a>  			}
<a class="jxr_linenumber" name="L77" href="#L77">77</a>  			<strong class="jxr_keyword">for</strong> (Feature current : ElementUtils.getAllElementsOfType(component, Feature.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L78" href="#L78">78</a>  				<strong class="jxr_keyword">if</strong> (!selectedElementList.contains(current)) {
<a class="jxr_linenumber" name="L79" href="#L79">79</a>  					possibleElementList.addElement(current);
<a class="jxr_linenumber" name="L80" href="#L80">80</a>  				}
<a class="jxr_linenumber" name="L81" href="#L81">81</a>  			}
<a class="jxr_linenumber" name="L82" href="#L82">82</a>  		} <strong class="jxr_keyword">else</strong> {
<a class="jxr_linenumber" name="L83" href="#L83">83</a>  			<em class="jxr_comment">// global rule with intercept some policy</em>
<a class="jxr_linenumber" name="L84" href="#L84">84</a>  			<em class="jxr_comment">// choose all ports vs. ports of "standard components"</em>
<a class="jxr_linenumber" name="L85" href="#L85">85</a>  			Package top = PackageUtil.getRootPackage(rule.getBase_Property());
<a class="jxr_linenumber" name="L86" href="#L86">86</a>  			<strong class="jxr_keyword">for</strong> (Feature current : ElementUtils.getAllElementsOfType(top, Feature.<strong class="jxr_keyword">class</strong>)) {
<a class="jxr_linenumber" name="L87" href="#L87">87</a>  				<strong class="jxr_keyword">if</strong> (!selectedElementList.contains(current)) {
<a class="jxr_linenumber" name="L88" href="#L88">88</a>  					possibleElementList.addElement(current);
<a class="jxr_linenumber" name="L89" href="#L89">89</a>  				}
<a class="jxr_linenumber" name="L90" href="#L90">90</a>  			}
<a class="jxr_linenumber" name="L91" href="#L91">91</a>  		}
<a class="jxr_linenumber" name="L92" href="#L92">92</a>  	}
<a class="jxr_linenumber" name="L93" href="#L93">93</a>  
<a class="jxr_linenumber" name="L94" href="#L94">94</a>  	<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L95" href="#L95">95</a>  <em class="jxr_comment">	 * (non-Javadoc)</em>
<a class="jxr_linenumber" name="L96" href="#L96">96</a>  <em class="jxr_comment">	 *</em>
<a class="jxr_linenumber" name="L97" href="#L97">97</a>  <em class="jxr_comment">	 * @see com.cea.papyrus.ui.dialogs.ChooseSetAssistedDialog#createDialogArea(org.eclipse.swt.widgets.Composite)</em>
<a class="jxr_linenumber" name="L98" href="#L98">98</a>  <em class="jxr_comment">	 */</em>
<a class="jxr_linenumber" name="L99" href="#L99">99</a>  	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L100" href="#L100">100</a> <em class="jxr_javadoccomment">	 * Creates the dialog area.</em>
<a class="jxr_linenumber" name="L101" href="#L101">101</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L102" href="#L102">102</a> <em class="jxr_javadoccomment">	 * @param parent</em>
<a class="jxr_linenumber" name="L103" href="#L103">103</a> <em class="jxr_javadoccomment">	 *            the parent</em>
<a class="jxr_linenumber" name="L104" href="#L104">104</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L105" href="#L105">105</a> <em class="jxr_javadoccomment">	 * @return the control</em>
<a class="jxr_linenumber" name="L106" href="#L106">106</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L107" href="#L107">107</a> 	@Override
<a class="jxr_linenumber" name="L108" href="#L108">108</a> 	<strong class="jxr_keyword">protected</strong> Control createDialogArea(Composite parent) {
<a class="jxr_linenumber" name="L109" href="#L109">109</a> 		Control composite = <strong class="jxr_keyword">super</strong>.createDialogArea(parent);
<a class="jxr_linenumber" name="L110" href="#L110">110</a> 
<a class="jxr_linenumber" name="L111" href="#L111">111</a> 		<em class="jxr_comment">// Add 2 columns to the table area</em>
<a class="jxr_linenumber" name="L112" href="#L112">112</a> 		<em class="jxr_comment">// possibleElementsTable.setLinesVisible(true);</em>
<a class="jxr_linenumber" name="L113" href="#L113">113</a> 		possibleElementsTable.setHeaderVisible(<strong class="jxr_keyword">true</strong>);
<a class="jxr_linenumber" name="L114" href="#L114">114</a> 
<a class="jxr_linenumber" name="L115" href="#L115">115</a> 		<em class="jxr_comment">// 1st column with image/checkboxes - NOTE: The SWT.CENTER has no effect!!</em>
<a class="jxr_linenumber" name="L116" href="#L116">116</a> 		TableColumn column = <strong class="jxr_keyword">new</strong> TableColumn(possibleElementsTable, SWT.CENTER, 0);
<a class="jxr_linenumber" name="L117" href="#L117">117</a> 		column.setText(<span class="jxr_string">"Port"</span>);
<a class="jxr_linenumber" name="L118" href="#L118">118</a> 		column.setWidth(60);
<a class="jxr_linenumber" name="L119" href="#L119">119</a> 		column.addSelectionListener(<strong class="jxr_keyword">new</strong> SelectionAdapter() {
<a class="jxr_linenumber" name="L120" href="#L120">120</a> 
<a class="jxr_linenumber" name="L121" href="#L121">121</a> 			@Override
<a class="jxr_linenumber" name="L122" href="#L122">122</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L123" href="#L123">123</a> 				possibleElementsTableViewer.setSorter(<strong class="jxr_keyword">new</strong> AlphabeticalViewerSorter(0));
<a class="jxr_linenumber" name="L124" href="#L124">124</a> 			}
<a class="jxr_linenumber" name="L125" href="#L125">125</a> 		});
<a class="jxr_linenumber" name="L126" href="#L126">126</a> 
<a class="jxr_linenumber" name="L127" href="#L127">127</a> 		<em class="jxr_comment">// 2nd column with task Description</em>
<a class="jxr_linenumber" name="L128" href="#L128">128</a> 		column = <strong class="jxr_keyword">new</strong> TableColumn(possibleElementsTable, SWT.LEFT, 1);
<a class="jxr_linenumber" name="L129" href="#L129">129</a> 		column.setText(<span class="jxr_string">"Type"</span>);
<a class="jxr_linenumber" name="L130" href="#L130">130</a> 		column.setWidth(100);
<a class="jxr_linenumber" name="L131" href="#L131">131</a> 		<em class="jxr_comment">// Add listener to column so tasks are sorted by description when clicked</em>
<a class="jxr_linenumber" name="L132" href="#L132">132</a> 		column.addSelectionListener(<strong class="jxr_keyword">new</strong> SelectionAdapter() {
<a class="jxr_linenumber" name="L133" href="#L133">133</a> 
<a class="jxr_linenumber" name="L134" href="#L134">134</a> 			@Override
<a class="jxr_linenumber" name="L135" href="#L135">135</a> 			<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">void</strong> widgetSelected(SelectionEvent e) {
<a class="jxr_linenumber" name="L136" href="#L136">136</a> 				possibleElementsTableViewer.setSorter(<strong class="jxr_keyword">new</strong> AlphabeticalViewerSorter(1));
<a class="jxr_linenumber" name="L137" href="#L137">137</a> 			}
<a class="jxr_linenumber" name="L138" href="#L138">138</a> 		});
<a class="jxr_linenumber" name="L139" href="#L139">139</a> 
<a class="jxr_linenumber" name="L140" href="#L140">140</a> 		<em class="jxr_comment">// set sorter to the possible element table viewer</em>
<a class="jxr_linenumber" name="L141" href="#L141">141</a> 		possibleElementsTableViewer.setSorter(<strong class="jxr_keyword">new</strong> AlphabeticalViewerSorter(0));
<a class="jxr_linenumber" name="L142" href="#L142">142</a> 
<a class="jxr_linenumber" name="L143" href="#L143">143</a> 		<strong class="jxr_keyword">return</strong> composite;
<a class="jxr_linenumber" name="L144" href="#L144">144</a> 	}
<a class="jxr_linenumber" name="L145" href="#L145">145</a> 
<a class="jxr_linenumber" name="L146" href="#L146">146</a> 	<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L147" href="#L147">147</a> <em class="jxr_comment">	 * (non-Javadoc)</em>
<a class="jxr_linenumber" name="L148" href="#L148">148</a> <em class="jxr_comment">	 *</em>
<a class="jxr_linenumber" name="L149" href="#L149">149</a> <em class="jxr_comment">	 * @see com.cea.papyrus.ui.dialogs.ChooseSetAssistedDialog#runAddElement(java.lang.String)</em>
<a class="jxr_linenumber" name="L150" href="#L150">150</a> <em class="jxr_comment">	 */</em>
<a class="jxr_linenumber" name="L151" href="#L151">151</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L152" href="#L152">152</a> <em class="jxr_javadoccomment">	 * Run add element.</em>
<a class="jxr_linenumber" name="L153" href="#L153">153</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L154" href="#L154">154</a> <em class="jxr_javadoccomment">	 * @param name</em>
<a class="jxr_linenumber" name="L155" href="#L155">155</a> <em class="jxr_javadoccomment">	 *            the name</em>
<a class="jxr_linenumber" name="L156" href="#L156">156</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L157" href="#L157">157</a> 	@Override
<a class="jxr_linenumber" name="L158" href="#L158">158</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">void</strong> runAddElement(String name) {
<a class="jxr_linenumber" name="L159" href="#L159">159</a> 		<em class="jxr_comment">// find the stereotype in the list</em>
<a class="jxr_linenumber" name="L160" href="#L160">160</a> 		Port port = <strong class="jxr_keyword">null</strong>;
<a class="jxr_linenumber" name="L161" href="#L161">161</a> 		<strong class="jxr_keyword">for</strong> (Object possibleElement : possibleElementList.getElements()) {
<a class="jxr_linenumber" name="L162" href="#L162">162</a> 			Port element = (Port) possibleElement;
<a class="jxr_linenumber" name="L163" href="#L163">163</a> 			<strong class="jxr_keyword">if</strong> (name.equalsIgnoreCase(element.getName()) || name.equalsIgnoreCase(element.getQualifiedName())) {
<a class="jxr_linenumber" name="L164" href="#L164">164</a> 				port = element;
<a class="jxr_linenumber" name="L165" href="#L165">165</a> 			}
<a class="jxr_linenumber" name="L166" href="#L166">166</a> 		}
<a class="jxr_linenumber" name="L167" href="#L167">167</a> 		<strong class="jxr_keyword">if</strong> (port != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L168" href="#L168">168</a> 			runActionAdd(port);
<a class="jxr_linenumber" name="L169" href="#L169">169</a> 		}
<a class="jxr_linenumber" name="L170" href="#L170">170</a> 	}
<a class="jxr_linenumber" name="L171" href="#L171">171</a> 
<a class="jxr_linenumber" name="L172" href="#L172">172</a> 	<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L173" href="#L173">173</a> <em class="jxr_comment">	 * (non-Javadoc)</em>
<a class="jxr_linenumber" name="L174" href="#L174">174</a> <em class="jxr_comment">	 *</em>
<a class="jxr_linenumber" name="L175" href="#L175">175</a> <em class="jxr_comment">	 * @see com.cea.papyrus.ui.dialogs.ChooseSetAssistedDialog#isSelectableElement(java.lang.String)</em>
<a class="jxr_linenumber" name="L176" href="#L176">176</a> <em class="jxr_comment">	 */</em>
<a class="jxr_linenumber" name="L177" href="#L177">177</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L178" href="#L178">178</a> <em class="jxr_javadoccomment">	 * Checks if is selectable element.</em>
<a class="jxr_linenumber" name="L179" href="#L179">179</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L180" href="#L180">180</a> <em class="jxr_javadoccomment">	 * @param text</em>
<a class="jxr_linenumber" name="L181" href="#L181">181</a> <em class="jxr_javadoccomment">	 *            the text</em>
<a class="jxr_linenumber" name="L182" href="#L182">182</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L183" href="#L183">183</a> <em class="jxr_javadoccomment">	 * @return true, if is selectable element</em>
<a class="jxr_linenumber" name="L184" href="#L184">184</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L185" href="#L185">185</a> 	@Override
<a class="jxr_linenumber" name="L186" href="#L186">186</a> 	<strong class="jxr_keyword">protected</strong> <strong class="jxr_keyword">boolean</strong> isSelectableElement(String text) {
<a class="jxr_linenumber" name="L187" href="#L187">187</a> 		<em class="jxr_comment">// iterate through all possibilities and return true if text corresponds</em>
<a class="jxr_linenumber" name="L188" href="#L188">188</a> 		<strong class="jxr_keyword">for</strong> (Object possibleElement : possibleElementList.getElements()) {
<a class="jxr_linenumber" name="L189" href="#L189">189</a> 			Port element = (Port) possibleElement;
<a class="jxr_linenumber" name="L190" href="#L190">190</a> 			<strong class="jxr_keyword">if</strong> (text.equalsIgnoreCase(element.getName()) || text.equalsIgnoreCase(element.getQualifiedName())) {
<a class="jxr_linenumber" name="L191" href="#L191">191</a> 				<strong class="jxr_keyword">return</strong> <strong class="jxr_keyword">true</strong>;
<a class="jxr_linenumber" name="L192" href="#L192">192</a> 			}
<a class="jxr_linenumber" name="L193" href="#L193">193</a> 		}
<a class="jxr_linenumber" name="L194" href="#L194">194</a> 		<strong class="jxr_keyword">return</strong> false;
<a class="jxr_linenumber" name="L195" href="#L195">195</a> 	}
<a class="jxr_linenumber" name="L196" href="#L196">196</a> 
<a class="jxr_linenumber" name="L197" href="#L197">197</a> 	<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L198" href="#L198">198</a> <em class="jxr_javadoccomment">	 * Content Proposal provider for stereotypes dialog. Propose the simple</em>
<a class="jxr_linenumber" name="L199" href="#L199">199</a> <em class="jxr_javadoccomment">	 * name of the stereotype and its qualified name.</em>
<a class="jxr_linenumber" name="L200" href="#L200">200</a> <em class="jxr_javadoccomment">	 *</em>
<a class="jxr_linenumber" name="L201" href="#L201">201</a> <em class="jxr_javadoccomment">	 * @author Remi Schnekenburger</em>
<a class="jxr_linenumber" name="L202" href="#L202">202</a> <em class="jxr_javadoccomment">	 */</em>
<a class="jxr_linenumber" name="L203" href="#L203">203</a> 	<strong class="jxr_keyword">public</strong> <strong class="jxr_keyword">class</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/transformation/ui/dialogs/ChoosePorts.html">ConfigOptContentProposalProvider</a> <strong class="jxr_keyword">extends</strong> DecoratedContentProposalProvider {
<a class="jxr_linenumber" name="L204" href="#L204">204</a> 
<a class="jxr_linenumber" name="L205" href="#L205">205</a> 		<em class="jxr_comment">/*</em>
<a class="jxr_linenumber" name="L206" href="#L206">206</a> <em class="jxr_comment">		 * (non-Javadoc)</em>
<a class="jxr_linenumber" name="L207" href="#L207">207</a> <em class="jxr_comment">		 *</em>
<a class="jxr_linenumber" name="L208" href="#L208">208</a> <em class="jxr_comment">		 * @see com.cea.papyrus.ui.dialogs.ChooseSetAssistedDialog.DecoratedContentProposalProvider#getProposals(java.lang.String, int)</em>
<a class="jxr_linenumber" name="L209" href="#L209">209</a> <em class="jxr_comment">		 */</em>
<a class="jxr_linenumber" name="L210" href="#L210">210</a> 		<em class="jxr_javadoccomment">/**</em>
<a class="jxr_linenumber" name="L211" href="#L211">211</a> <em class="jxr_javadoccomment">		 * Gets the proposals.</em>
<a class="jxr_linenumber" name="L212" href="#L212">212</a> <em class="jxr_javadoccomment">		 *</em>
<a class="jxr_linenumber" name="L213" href="#L213">213</a> <em class="jxr_javadoccomment">		 * @param contents</em>
<a class="jxr_linenumber" name="L214" href="#L214">214</a> <em class="jxr_javadoccomment">		 *            the contents</em>
<a class="jxr_linenumber" name="L215" href="#L215">215</a> <em class="jxr_javadoccomment">		 * @param position</em>
<a class="jxr_linenumber" name="L216" href="#L216">216</a> <em class="jxr_javadoccomment">		 *            the position</em>
<a class="jxr_linenumber" name="L217" href="#L217">217</a> <em class="jxr_javadoccomment">		 *</em>
<a class="jxr_linenumber" name="L218" href="#L218">218</a> <em class="jxr_javadoccomment">		 * @return the proposals</em>
<a class="jxr_linenumber" name="L219" href="#L219">219</a> <em class="jxr_javadoccomment">		 */</em>
<a class="jxr_linenumber" name="L220" href="#L220">220</a> 		@Override
<a class="jxr_linenumber" name="L221" href="#L221">221</a> 		<strong class="jxr_keyword">public</strong> DecoratedContentProposal[] getProposals(String contents, <strong class="jxr_keyword">int</strong> position) {
<a class="jxr_linenumber" name="L222" href="#L222">222</a> 			ArrayList&lt;DecoratedContentProposal&gt; proposals = <strong class="jxr_keyword">new</strong> ArrayList&lt;DecoratedContentProposal&gt;();
<a class="jxr_linenumber" name="L223" href="#L223">223</a> 
<a class="jxr_linenumber" name="L224" href="#L224">224</a> 			<strong class="jxr_keyword">if</strong> (possibleElementList != <strong class="jxr_keyword">null</strong>) {
<a class="jxr_linenumber" name="L225" href="#L225">225</a> 				<strong class="jxr_keyword">for</strong> (Object portObj : possibleElementList.getElements()) {
<a class="jxr_linenumber" name="L226" href="#L226">226</a> 					<strong class="jxr_keyword">final</strong> <a href="../../../../../../../../org/eclipse/papyrus/designer/components/FCM/Port.html">Port</a> port = (Port) portObj;
<a class="jxr_linenumber" name="L227" href="#L227">227</a> 					<strong class="jxr_keyword">final</strong> String simpleName = port.getName();
<a class="jxr_linenumber" name="L228" href="#L228">228</a> 					<strong class="jxr_keyword">final</strong> String qualifiedName = port.getQualifiedName();
<a class="jxr_linenumber" name="L229" href="#L229">229</a> 
<a class="jxr_linenumber" name="L230" href="#L230">230</a> 					<strong class="jxr_keyword">if</strong> (position &lt; simpleName.length() &amp;&amp; contents.substring(0, position).equalsIgnoreCase(simpleName.substring(0, position))) {
<a class="jxr_linenumber" name="L231" href="#L231">231</a> 						proposals.add(<strong class="jxr_keyword">new</strong> DecoratedContentProposal(port, labelProvider));
<a class="jxr_linenumber" name="L232" href="#L232">232</a> 					}
<a class="jxr_linenumber" name="L233" href="#L233">233</a> 
<a class="jxr_linenumber" name="L234" href="#L234">234</a> 					<strong class="jxr_keyword">if</strong> (position &lt; qualifiedName.length() &amp;&amp; contents.substring(0, position).equalsIgnoreCase(qualifiedName.substring(0, position))) {
<a class="jxr_linenumber" name="L235" href="#L235">235</a> 						proposals.add(<strong class="jxr_keyword">new</strong> DecoratedContentProposal(port, qualifiedLabelProvider));
<a class="jxr_linenumber" name="L236" href="#L236">236</a> 					}
<a class="jxr_linenumber" name="L237" href="#L237">237</a> 				}
<a class="jxr_linenumber" name="L238" href="#L238">238</a> 			}
<a class="jxr_linenumber" name="L239" href="#L239">239</a> 
<a class="jxr_linenumber" name="L240" href="#L240">240</a> 			Collections.sort(proposals);
<a class="jxr_linenumber" name="L241" href="#L241">241</a> 			<strong class="jxr_keyword">return</strong> proposals.toArray(<strong class="jxr_keyword">new</strong> DecoratedContentProposal[proposals.size()]);
<a class="jxr_linenumber" name="L242" href="#L242">242</a> 		}
<a class="jxr_linenumber" name="L243" href="#L243">243</a> 	}
<a class="jxr_linenumber" name="L244" href="#L244">244</a> }
</pre>
<hr/>
<div id="footer">Copyright &#169; 2016 <a href="https://www.eclipse.org/">Eclipse foundation</a>. All rights reserved.</div>
</body>
</html>
